#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include "DBEngine.h"

std::vector<std::string> tokenize(std::string ss);
void displayTokenList(std::vector<std::string> input);
Relation condition(std::vector<std::string> input, Relation &r, DBEngine &engine);
tuple<std::vector<std::string>, Relation> expression(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> showCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> saveCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> closeCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> openCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> exitCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> createCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> insertCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> updateCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> deleteCMD(std::vector<std::string> input, DBEngine &engine);
std::vector<std::string> query(std::vector<std::string> input, DBEngine &engine);
void par_line(std::vector<std::string> input, DBEngine &engine);
void parse(std::string s, DBEngine &e);